%{

# include "basic.h"
# include "CPAGrammar.h"

int sourceLineNumber=1;
	
%}

DIGIT			[0-9]
IDENTIFIER		[a-zA-Z][a-zA-Z0-9]*

%%

{DIGIT}+ 	          { yylval.inum = atoi(yytext); return TOK_INTEGER; }
{DIGIT}+"."{DIGIT}*	 { yylval.fnum = atof(yytext); return TOK_FLOAT; }

"->"	                { return TOK_TO; }
"emits"	             { return TOK_EMITS; }
"normal-X"            { return TOK_NORMAL_X; }
"normal-Y"            { return TOK_NORMAL_Y; }
"axis"                { return TOK_AXIS; }
"polarized"           { return TOK_POLARIZED; } 
"state"               { return TOK_STATE; }
"color"               { return TOK_COLOR; }
"transitions"         { return TOK_TRANSITIONS; }
{IDENTIFIER}	       { yylval.cstring = new string (yytext);
                        // cerr << "Returning identifier: " << *(yylval.cstring) << endl;
                        return TOK_IDENTIFIER; }
"{"	                { return TOK_LBRACE; }
"}"                   { return TOK_RBRACE; }
"("	                { return '('; }
")"	                { return ')'; }
";"	                { return ';'; }
"&"	                { return '&'; }
","	                { return ','; }
"<="	                { return TOK_LTE; }

"/*"[^}\n]*"*/"       { /* eat up one-line comments */ }
[ \t]+                { /* eat up whitespace */ }
[\n]                  { sourceLineNumber++; }
.                       { printf( "Unrecognized character: %s\n", yytext ); }

%%

int yywrap()
{
	return 1;
}



