#ifndef __CELLPROGRAM_H__
#define __CELLPROGRAM_H__

class CellProgram
{
private:
  bool resolved;

protected:
  // I'm sure there's a better C++ way to do this, but STL vector seems
  // very convoluted to me.
  int nelements;
  int nspace;
  CellState **elements;
  void grow (void);
  string *states;

  int nchemicals;
  int maxchemicals;
  string *chemicals;

 public:
  CellStateId initialState, finalState;
  
public:
  CellProgram ();
  ~CellProgram ();

  void addState (CellState *state);
  void resolveStates ();
  int lookupState (string) const; // -1 if state is not found
  int lookupAddChemical (string); // adds it if not found
  const string toString () const;
 
  CellState *getState (CellStateId) const;
  bool hasStateColor (CellStateId) const;
  int getStateColor (CellStateId) const;

  void getTransition (CellStateId p_current, Environment *p_env, 
                      CellStateId *p_next1, CellStateId *p_next2, t_splitKind *mode) const;
  EmissionList *getEmissions (CellStateId p_current) const;
};

# endif
