#ifndef __CELLTRANSITION_H__
#define __CELLTRANSITION_H__

class CellTransition
{
protected:
  ConcentrationList *chemicals;
  string *nextstate;
  int nextstateid;

public:
  CellTransition (ConcentrationList *p_chemicals, string *p_state); /* transition */
  virtual string toString ();
  virtual void resolveStates (CellProgram *) ;
  void resolveChemicals (CellProgram *p_cpa) ;
  virtual void setNextStates (CellStateId *p_next1, CellStateId *p_next2, t_splitKind *p_mode) const ;
  bool matchesEnvironment (Environment *env) const;
};

class CellSplit : public CellTransition 
{
protected:
  // inherited from CellTransition: string nextstate;
  string *splitstate;
  int splitstateid;
  t_splitKind split;

public:
  CellSplit (ConcentrationList *p_chemicals, string *p_state1, string *p_state2, t_splitKind); 
  virtual string toString ();
  virtual void resolveStates (CellProgram *) ;
  virtual void setNextStates (CellStateId *p_next1, CellStateId *p_next2, t_splitKind *p_mode) const ;
};

# endif

