/*
** Emission.cc
*/

# include "basic.h"
# include <stdio.h>

Emission::Emission (string p_name, float p_amount)
{
  name = p_name;
  amount = p_amount;
  id = ChemicalId_INVALID;
}

Emission::Emission (ChemicalId p_id, float p_amount)
{
  name = "";
  amount = p_amount;
  id = p_id;
}

void Emission::resolveChemicals (CellProgram *cpa)
{
  id = cpa->lookupAddChemical (name);
}

ChemicalId Emission::getChemical () const
{
  assert (id != ChemicalId_INVALID);
  return id;
}

float Emission::getConcentration () const
{
  return amount;
}

void Emission::increaseConcentration (float val) 
{
  amount += val;
}

const string Emission::toString () const
{
  string s = "";
  char buf[128];

  s += name;
  s += " [";
  snprintf (buf, 128, "%f", amount);
  s += buf;
  s += "]";
  return s;
}
  
