/*
** Environment.cc
*/

# include "basic.h"

Environment::Environment () {
  emits = new EmissionList ();
}

Environment::~Environment () {
  delete emits;
}

void Environment::reflect (Chemical *chem) {
  bool already = false;
  emits->startIterator ();

  while (emits->hasMore ()) {
    Emission *emit = emits->getNext ();
    
    if (emit->getChemical () == chem->id) {
      emit->increaseConcentration (chem->concentration);
      already = true;
      break;
    }
  }

  emits->finishIterator ();

  if (!already) {
    emits->add (new Emission (chem->id, chem->concentration));
  }
}

void Environment::startIterator () {
  emits->startIterator ();
}

Emission *Environment::getNext () {
  return emits->getNext ();
}

bool Environment::hasMore () {
  return emits->hasMore ();
}

void Environment::finishIterator () {
  emits->finishIterator ();
}

string Environment::toString () const {
  return emits->toString ();
}
