/*
** basic.h
*/

# ifndef I__BASIC_H__I
# define I__BASIC_H__I

#define __cplusplus

# include <math.h>
# include <time.h>
# include <stdio.h>
# include <stdlib.h>
# include <string>
# include <vector>
# include <iostream>
# include <fstream>
# include "../threads/thread.h"

using namespace std;

class CellProgram;
extern CellProgram *g_cellProgram;
extern ofstream g_DumpFile;

extern int g_tick;

class CellSimulator;
extern CellSimulator g_simulator;

class Environment;

extern void exitProgram ();

enum e_threadIds { DISPLAY_TID = 0, SIMULATOR_TID, CELL_THREAD_BASE };

typedef enum e_splitKinds { SPLIT_ERROR = -1,  SPLIT_AXIS=0, SPLIT_POLARIZED, SPLIT_NORMAL_1, SPLIT_NORMAL_2 } t_splitKind;

typedef long int CellStateId;
typedef long int ChemicalId;
# define ChemicalId_INVALID -1

/*
** Get rid of this!
*/

class Chemical
{
public:
  ChemicalId id;
  float concentration;
};

# include "constants.h"

# include "ChemicalConcentration.h"
# include "ConcentrationList.h"

# include "CellTransition.h"
# include "CellTransitionList.h"

# include "Emission.h"
# include "EmissionList.h"
# include "Environment.h"

# include "CellState.h"
# include "CellProgram.h"

# include "mailbox.h"

# include "SimInstruction.h"
# include "SimInstructions.h"

# include "SimCell.h"
# include "CellSimulator.h"

# include "display.h"

# else
# error "Multiple include"
# endif

